Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Static Public Member Functions
Lucene::Collector Class Referenceabstract

Collectors are primarily meant to be used to gather raw results from a search, and implement sorting or custom result filtering, collation, etc. More...

`#include <Collector.h>`

Inheritance diagram for Lucene::Collector:

## Public Member Functions

virtual | ~Collector ()
virtual String | getClassName ()
boost::shared_ptr< Collector > | shared_from_this ()
virtual void | setScorer (ScorerPtr scorer)=0
| Called before successive calls to collect(int32_t). Implementations that need the score of the current document (passed-in to collect(int32_t)), should save the passed-in Scorer and call scorer.score() when needed. More...
virtual void | collect (int32_t doc)=0
| Called once for every document matching a query, with the unbased document number. More...
virtual void | setNextReader (IndexReaderPtr reader, int32_t docBase)=0
| Called before collecting from each IndexReader. All doc ids in collect(int32_t) will correspond to reader. Add docBase to the current IndexReaders internal document id to re-base ids in collect(int32_t). More...
virtual bool | acceptsDocsOutOfOrder ()=0
| Return true if this collector does not require the matching docIDs to be delivered in int sort order (smallest to largest) to collect. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (LuceneObjectPtr other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (LuceneObjectPtr other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (LuceneObjectPtr other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

Collectors are primarily meant to be used to gather raw results from a search, and implement sorting or custom result filtering, collation, etc.

Lucene's core collectors are derived from Collector. Likely your application can use one of these classes, or subclass TopDocsCollector, instead of implementing Collector directly:

- TopDocsCollector is an abstract base class that assumes you will retrieve the top N docs, according to some criteria, after collection is done.

- TopScoreDocCollector is a concrete subclass TopDocsCollector and sorts according to score + docID. This is used internally by the IndexSearcher search methods that do not take an explicit Sort. It is likely the most frequently used collector.

- TopFieldCollector subclasses TopDocsCollector and sorts according to a specified Sort object (sort by field). This is used internally by the IndexSearcher search methods that take an explicit Sort.

- TimeLimitingCollector, which wraps any other Collector and aborts the search if it's taken too much time.

- PositiveScoresOnlyCollector wraps any other Collector and prevents collection of hits whose score is <= 0.0

Collector decouples the score from the collected doc: the score computation is skipped entirely if it's not needed. Collectors that do need the score should implement the setScorer method, to hold onto the passed Scorer instance, and call Scorer#score() within the collect method to compute the current hit's score. If your collector may request the score for a single hit multiple times, you should use ScoreCachingWrappingScorer.

NOTE: The doc that is passed to the collect method is relative to the current reader. If your collector needs to resolve this to the docID space of the Multi*Reader, you must re-base it by recording the docBase from the most recent setNextReader call. Here's a simple example showing how to collect docIDs into a BitSet:

    class MyCollector : public Collector
    {
    public:
        MyCollector(BitSetPtr bits)
        {
            this->bits = bits;
            this->docBase = 0;
        }

    protected:
        BitSetPtr bits;
        int32_t docBase;

    public:
        virtual void setScorer(ScorerPtr scorer)
        {
            // ignore scorer
        }

        virtual void collect(int32_t doc)
        {
            bits->set(doc + docBase);
        }

        virtual void setNextReader(IndexReaderPtr reader, int32_t docBase)
        {
            this->docBase = docBase;
        }

        virtual bool acceptsDocsOutOfOrder()
        {
            return true; // accept docs out of order (for a BitSet it doesn't matter)
        }
    };

    ...

    SearcherPtr searcher = newLucene<IndexSearcher>(indexReader);
    BitSetPtr bits = newLucene<BitSet>(indexReader->maxDoc());
    searcher->search(query, newLucene<MyCollector>(bits));

Not all collectors will need to rebase the docID. For example, a collector that simply counts the total number of hits would skip it.

NOTE: Prior to 2.9, Lucene silently filtered out hits with score <= 0. As of 2.9, the core Collectors no longer do that. It's very unusual to have such hits (a negative query boost, or function query returning negative custom scores, could cause it to happen). If you need that behavior, use PositiveScoresOnlyCollector.

## Constructor & Destructor Documentation

virtual Lucene::Collector::~Collector | ( | ) |  |

virtual

## Member Function Documentation

static String Lucene::Collector::_getClassName | ( | ) |  |

inline static

virtual bool Lucene::Collector::acceptsDocsOutOfOrder | ( | ) |  |

pure virtual

Return true if this collector does not require the matching docIDs to be delivered in int sort order (smallest to largest) to collect.

Most Lucene Query implementations will visit matching docIDs in order. However, some queries (currently limited to certain cases of BooleanQuery) can achieve faster searching if the Collector allows them to deliver the docIDs out of order.

Many collectors don't mind getting docIDs out of order, so it's important to return true here.

Implemented in Lucene::TimeLimitingCollector, Lucene::BooleanScorerCollector, Lucene::TopFieldCollector, and Lucene::PositiveScoresOnlyCollector.

virtual void Lucene::Collector::collect | ( | int32_t | doc) |  |

pure virtual

Called once for every document matching a query, with the unbased document number.

Note: This is called in an inner search loop. For good search performance, implementations of this method should not call Searcher#doc(int32_t) or IndexReader#document(int32_t) on every hit. Doing so can slow searches by an order of magnitude or more.

Implemented in Lucene::TimeLimitingCollector, Lucene::BooleanScorerCollector, and Lucene::PositiveScoresOnlyCollector.

virtual String Lucene::Collector::getClassName | ( | ) |  |

inline virtual

Reimplemented in Lucene::BooleanScorerCollector, Lucene::TimeLimitingCollector, Lucene::TopDocsCollector, Lucene::TopScoreDocCollector, Lucene::TopFieldCollector, and Lucene::PositiveScoresOnlyCollector.

virtual void Lucene::Collector::setNextReader | ( | IndexReaderPtr | reader,
|  | int32_t | docBase
| ) |  |

pure virtual

Called before collecting from each IndexReader. All doc ids in collect(int32_t) will correspond to reader. Add docBase to the current IndexReaders internal document id to re-base ids in collect(int32_t).

Parameters

  reader | next IndexReader
  docBase |

Implemented in Lucene::TimeLimitingCollector, Lucene::BooleanScorerCollector, Lucene::TopScoreDocCollector, and Lucene::PositiveScoresOnlyCollector.

virtual void Lucene::Collector::setScorer | ( | ScorerPtr | scorer) |  |

pure virtual

Called before successive calls to collect(int32_t). Implementations that need the score of the current document (passed-in to collect(int32_t)), should save the passed-in Scorer and call scorer.score() when needed.

Implemented in Lucene::TimeLimitingCollector, Lucene::BooleanScorerCollector, Lucene::TopScoreDocCollector, and Lucene::PositiveScoresOnlyCollector.

boost::shared_ptr< Collector > Lucene::Collector::shared_from_this | ( | ) |  |

inline

The documentation for this class was generated from the following file:

- Collector.h

clucene.sourceforge.net